# -*- coding: utf-8-unix -*-
%bcond_with firstbuild

#%%global _use_internal_dependency_generator 0
#%%global __find_provides %{SOURCE99}
#%%global __find_requires %{SOURCE98}
%global __find_requires %{nil}

%global texlivesrcver   20190410
#% global tlptexlivesrcver   20140507

#%%define luatexver	0.87.0
#%%define	builddir	%{_builddir}/%{name}-source-%{texlivesrcver}
%define	builddir	%{_builddir}/%{name}-%{texlivesrcver}-source

Summary: The TeX text formatting system
Name: texlive
Version: 2019
Release: 1%{?_dist_release}
License: distributable
Group: Applications/Publishing
URL: http://www.tug.org/texlive/

## original TeX Live source
Source: ftp://tug.org/historic/systems/texlive/%{version}/%{name}-%{texlivesrcver}-source.tar.xz
## snapshot
# $ rsync -a --delete --exclude=.svn tug.org::tldevsrc/Build/source/ texlive-source-YYYYMMDD
# $ tar -cf - texlive-source-YYYYMMDD | pxz -9 > texlive-source-YYYYMMDD.tar.xz
#Source: %{name}-source-%{texlivesrcver}.tar.xz

## tlptexlive: pmetapost
#Source1: http://www.preining.info/software/build-tlptexlive-%{tlptexlivesrcver}.zip
Source2: http://www.tug.org/texlive/updmap-kanji.html

## our updmap{,-hdr}.cfg from collection-basic 20130823
# NOTE: 
# * texmf.cnf: we use the conf file texmf.cnf generated from Source0
Source6: updmap-hdr.cfg.texlive-%{texlivesrcver}-osxws
Source7: updmap.cfg.texlive-%{texlivesrcver}-osxws

## desktop files
Source11: texdoctk.desktop

# ## pxdvi from tlptexlive 2012
# Source50: texlive-source-xdvik-20130106.tar.xz
# Source51: http://www.preining.info/software/build-tlptexlive-20130106.zip

Source98: find-requires-texlive-osx.sh
## find library sonames for libkpathsea and libptexenc
Source99:  find-provides-texlive-osx.sh

## etc...
#Source100: texlive.cron

## luatex for OSX ElCapitan
#Source100: luatex-beta-%{luatexver}-osxws.tar.xz
#Source101: luaotfload-git20151218.tar.xz

######
# TeX patches
######

## vine / OSXWS
Patch0:		reautoconf-parallel.diff
#Patch1:		texlive-%{texlivesrcver}-vine.patch
Patch2:		texlive-%{texlivesrcver}-texmfcnf-osxws.patch
Patch3:		texlive-%{texlivesrcver}-set-selfautoparent-osxws.patch
#Patch4:		texlive-%{texlivesrcver}-lua52.patch
#Patch5:		texlive-%{texlivesrcver}-clang503.patch
#Patch10:	texlive-%{texlivesrcver}-pxdvik-vine.patch

# fedora texlive-base-20190410-6.fc32
Patch17: texlive-20180414-new-poppler.patch
Patch18: texlive-20190410-poppler-0.83.patch
Patch19: texlive-20190410-failedtests.patch

Patch20: texlive-20190410-dvisvgm-gs.patch

Patch100:	kanji-config-updmap-osxws-2016.diff
Patch101:	kanji-config-updmap-highsierra.diff
Patch102:	pdftoepdf-nocxx11.diff

#Patch101:	luatex-svn5328-otc_20151005.diff

## security

#Requires:    perl-Tk perl-Tk-TableMatrix
Requires:    ghostscript >= 8.71
Requires:    nkf
#Requires:    poppler
Requires:    libpaper
Requires:    libkpathsea
Requires:    libptexenc
Requires:    pixman
Requires:    t1lib
Requires:    icu
Requires:    libicu
Requires:    gd gmp
Requires:    harfbuzz
Requires:    mpfr
Requires(post,postun):    libkpathsea
Requires(post,postun):    libptexenc
#Requires(post,postun): fontconfig
#Requires(post): ed mktemp
Requires(post,postun): OSX-base
%{!?with_firstbuild:Requires: texlive-common = %{version}}
BuildRequires: bison flex
BuildRequires: bzip2-devel
BuildRequires: zlib-devel
BuildRequires: libpng-devel
BuildRequires: gd-devel
BuildRequires: gmp-devel
BuildRequires: mpfr-devel
BuildRequires: harfbuzz-devel
BuildRequires: ncurses-devel
BuildRequires: libjpeg-devel
BuildRequires: pixman-devel
#BuildRequires: XOrg-devel 
#BuildRequires: freetype2-devel >= 2.1.10
BuildRequires: autoconf >= 2.68
#BuildRequires: openMotif-devel
#BuildRequires: poppler-devel >= 0.80
BuildRequires: openssl-devel
BuildRequires: libpaper-devel
BuildRequires: libicu-devel
#BuildRequires: fontconfig-devel
BuildRequires: nkf
## needs to build pxdvi
BuildRequires: t1lib-devel

Obsoletes: texmacro-otf

BuildRequires: texlive-vtlpkg = %{version}

Buildroot:    %{_tmppath}/%{name}-%{version}-root

Vendor:       OSX WorkShop
Distribution: OSX WorkShop

%description
The TeX Live software distribution offers a complete TeX system for a
variety of Unix, Macintosh, Windows and other platforms. It
encompasses programs for editing, typesetting, previewing and printing
of TeX documents in many different languages, and a large collection
of TeX macros and font libraries.

The distribution includes extensive general documentation about TeX,
as well as the documentation for the included software packages.


%package doc
Summary: TeX Live: Documentation files of %{name}
Group: Applications/Publishing
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
This package contains documentation files of %{name}.

%package -n libkpathsea
Summary: path search library for the TeX Live
Group: System Environment/Libraries

%description -n libkpathsea
This package includes runtime part of the Kpathsea library.


%package -n libkpathsea-devel
Summary: path search libary and header files for the TeX Live
Group: Development/Libraries
Requires: libkpathsea = %{version}-%{release}

%description -n libkpathsea-devel
This package includes static library and header files of the Kpathsea library.


%package -n libptexenc
Summary: Kanji code convert library for Japanese pTeX
Group: System Environment/Libraries
Requires: libkpathsea = %{version}-%{release}

%description -n libptexenc
This package includes runtime part of the ptexenc library.


%package -n libptexenc-devel
Summary: Kanji code convert library and header files for Japanese pTeX
Group: Development/Libraries
Requires: libptexenc = %{version}-%{release}

%description -n libptexenc-devel
This package includes header files of the ptexenc library.


%prep
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && %__rm -rf %{buildroot}

%setup -q -n %{name}-%{texlivesrcver}-source
# %setup -q -n %{name}-source-%{texlivesrcver} -a 1

%patch0 -p0 -b .parallel
#%patch1 -p1 -b .osxws
%patch2 -p1 -b .texmfcnf
%patch3 -p1 -b .selfautoparent
#%patch4 -p0 -b .lua52
#%patch5 -p0 -b .clang503

#%patch17 -p1 -b .newpoppler
#%patch18 -p1 -b .poppler-0.83
%patch19 -p1 -b .failedtests

%patch20 -p0 -b .gs

#%patch100 -p0 -b .osxws
#%patch101 -p0 -b .highsierra

# luatex for Hiragino ttc
#%patch101 -p2

## Applying tlptexlive that provides pxdvi(k) and pmpost
echo "applying patches"
cat "$(pwd)/build-tlptexlive-%{tlptexlivesrcver}/patches/series" | while read p r ; do
    echo $p | grep '^#' >/dev/null  || \
    patch -p1 $r < "$(pwd)/build-tlptexlive-%{tlptexlivesrcver}/patches/$p" || exit 1
done

## Avoid pollution from internal libraries.
#%__rm -rf ./libs/{cairo,expat,freetype,freetype2,gd,jpeg,libpng,libttf,ncurses,pixman,poppler,t1lib,unzip,xpdf,zlib} || exit 1
## in OSXWS, use gd and freetype2
#%__rm -rf ./libs/{cairo,expat,freetype,jpeg,libpng,libttf,ncurses,pixman,poppler,t1lib,unzip,xpdf,zlib} || exit 1
%__rm -rf ./libs/{cairo,expat,freetype,jpeg,libpng,libttf,ncurses,pixman,t1lib,unzip,zlib} || exit 1
./reautoconf || exit 1

## fix install_name of libkpathsea and ptexenc
for i in ./texk/{kpathsea,ptexenc,web2c}/Makefile.in ./libs/lua{53,jit}/Makefile.in
do
        sed -i -e "s,-rpath \$(libdir),-rpath %{_libdir},g" \
	       -e "s,-rpath \@libdir@,-rpath %{_libdir},g" $i
done
#sed -i -e "s,^libtexluajit_la_LDFLAGS = ,libtexluajit_la_LDFLAGS = -rpath %{_libdir} ,g" \
#	libs/luajit/Makefile.in
#sed -i -e "s,^libtexlua52_la_LDFLAGS = ,libtexlua52_la_LDFLAGS = -rpath %{_libdir} ,g" \
#	libs/lua52/Makefile.in

## luatex for OSX ElCapitan
#rm -rf texk/web2c/luatexdir
#rm -rf libs/lua*
#tar zxf %{SOURCE100}

#%patch102 -p0 -b .nocxx11

%build
set -x
unset TEXINPUTS || :
unset HOME || :

export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
#export CFLAGS="-Os -arch x86_64 -mtune=core2 -fno-strict-aliasing -I%{_includedir}"
export CFLAGS="-O3 -m64 -mtune=core2 -fno-strict-aliasing -I%{_includedir}"
export CXXFLAGS="$CFLAGS -std=c++11 -stdlib=libc++"
export LDFLAGS="$LDFLAGS -L%{_libdir}"
export LANG=C

PREFIX=$(pwd)/work

#TL_CONF_XDVI_TOOLKIT=--with-xdvi-x-toolkit=motif
TL_MAKE_FLAGS=-j$(/usr/bin/getconf _NPROCESSORS_ONLN)

TL_CONFIGURE_ARGS=" \
    --disable-multiplatform \
    --disable-native-texlive-build \
    --with-banner-add=\"/OSX WorkShop\" \
    --enable-shared --disable-static \
    --enable-compiler-warnings=max \
    --without-cxx-runtime-hack \
    \
    --enable-web2c \
    --enable-web-progs --enable-dvipdfmx --enable-mendexk \
    --enable-makejvf --enable-pxdvik --enable-dvipsk \
    --enable-tetex --enable-texlive \
    \
    --without-system-gd \
    --with-system-gmp \
    --with-system-mpfr \
    --with-system-harfbuzz \
    --with-system-t1lib \
    --with-system-libpng \
    --with-system-zlib \
    --with-system-libpaper \
    --without-system-freetype2 \
    --with-system-pixman \
    --with-system-cairo \
    --with-system-icu \
    --with-system-libgs \
    --with-libgs-includes=%{_includedir} \
    --with-libgs-libdir=%{_libdir} \
    --with-pic \
    --without-x \
    \
    --disable-xindy --disable-xindy-docs --disable-xindy-make-rules \
    --disable-dvi2tty \
    --disable-t1utils --disable-psutils --disable-detex \
    --disable-dvipng --disable-lcdf-typetools \
"

export TL_CONF_XDVI_TOOLKIT TL_MAKE_FLAGS TL_CONFIGURE_ARGS
export LT_SYS_LIBRARY_PATH=%{_libdir}
TL_MAKE=%__make ./Build || exit 1


## luatex for ttc fonts (ElCapitan)
#pushd luatex-beta-%{luatexver}
#./build.sh --parallel --jit --clang
#popd

%install
## prepare %%install session
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && %__rm -rf %{buildroot}
export DYLD_LIBRARY_PATH="`pwd`/inst/lib"

## copy inst directory to /usr
%__mkdir_p %{buildroot}%{_prefix}
%__cp -a inst/* %{buildroot}%{_prefix} || exit 1
#%ifarch x86_64
#%__mv %{buildroot}%{_prefix}/lib %{buildroot}%{_libdir} || exit 1
#%endif
if [ -f %{buildroot}%{_libdir}/kpathsea/c-auto.h ]; then
   %__mv %{buildroot}%{_libdir}/kpathsea/c-auto.h \
         %{buildroot}%{_includedir}/kpathsea/c-auto.h || exit 1
   %__rm -r %{buildroot}%{_libdir}/kpathsea || exit 1
fi

## make some fundamental texmf trees
%__mkdir_p %{buildroot}%{_tl_texmfvine}
%__mkdir_p %{buildroot}%{_tl_texmfdist}
%__mkdir_p %{buildroot}%{_tl_texmflocal}
%__mkdir_p %{buildroot}%{_tl_texmfsysconfig}
%__mkdir_p %{buildroot}%{_tl_texmfsysvar}
%__mkdir_p %{buildroot}%{_tl_vartexfonts}
%__mkdir_p %{buildroot}%{_tl_texmfvine}/fonts/{truetype,opentype}
%__mkdir_p %{buildroot}%{_tl_texmfvine}/fonts/cmap

cat<<EOF>%{buildroot}%{_tl_texmfdist}/README.vine || exit 1
The directory %{_tl_texmfdist} is the texmf tree of the TeX Live 
distribution wide. 
You must not do any changes in this directory. 
EOF

cat<<EOF>%{buildroot}%{_tl_texmfvine}/README.vine || exit 1
The directory %{_tl_texmfvine} is the texmf tree of our distribution wide. 
You should not use this directory to manage any other packages because 
we Project Vine use this directory to manage non-CTAN packages, some 
enhancement packages and so on. 
EOF

cat<<EOF>%{buildroot}%{_tl_texmflocal}/README.vine || exit 1
The directory %{_tl_texmflocal} is the texmf tree of the system wide. 
If you are a privileged user of this system, 
you can use this directory to manage your local packages. 
EOF

## our texmf-dist/web2c/updmap{,-hdr}.cfg
%__mkdir_p %{buildroot}%{_tl_texmfdist}/web2c
%__cp -a %{SOURCE6} %{buildroot}%{_tl_texmfdist}/web2c/updmap-hdr.cfg || exit 1
%__cp -a %{SOURCE7} %{buildroot}%{_tl_texmfdist}/web2c/updmap.cfg || exit 1

# from texmacro-otf
ln -sf kanji-config-updmap-sys %{buildroot}%{_bindir}/updmap-otf

## luatex for OSX ElCapitan
#%__mkdir_p %{buildroot}%{_tl_texmfdist}/tex/luatex/luaotfload
#%__cp -a luaotfload-git20151218/src/* %{buildroot}%{_tl_texmfdist}/tex/luatex/luaotfload
#%__cp -a luaotfload-git20151218/scripts/* %{buildroot}%{_tl_texmfdist}/scripts/luaotfload
#%__cp -fa luatex-beta-%{luatexver}/build-clang/texk/web2c/{luatex,luajittex} \
#	%{buildroot}%{_bindir}

## our map files for dvipdfmx
#%__mkdir_p %{buildroot}%{_tl_aliasttfdir}
#%__mkdir_p %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvipdfmx/vine
#for x in ptex uptex otf otf-up; do 
#    touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvipdfmx/vine/${x}-vine.map
#done
#for x in FutoGo-Bold FutoMin-Bold Gothic-Medium MaruGo-Medium Mincho-Medium; do
#    touch %{buildroot}%{_tl_aliasttfdir}/${x}.ttf
#done

## desktop things
%__mkdir_p %{buildroot}%{_datadir}/applications
# %__install -m0644 -c %{SOURCE10} %{buildroot}%{_datadir}/applications/
%__install -m0644 -c %{SOURCE11} %{buildroot}%{_datadir}/applications/

# for created fonts
%__mkdir_p %{buildroot}%{_tl_vartexfonts}
# %__mkdir_p %{buildroot}%{_sysconfdir}/cron.daily
# %__install -m 755 %{SOURCE100} %{buildroot}%{_sysconfdir}/cron.daily/

## set executable bit for the library
%__chmod a+x %{buildroot}%{_libdir}/libkpathsea.*.dylib
%__chmod a+x %{buildroot}%{_libdir}/libptexenc.*.dylib

# configure ConTeXt
for x in context luatools texexec texmfstart; do
  %__sed -i -e 's|mtxrun|export TEXMF=%{_tl_texmfconfig}:%{_tl_texmfvar}:%{_tl_texmfhome}:%{_tl_texmfsysconfig}:%{_tl_texmfsysvar}:%{_tl_texmflocal}:%{_tl_texmfvine}:%{_tl_texmfdist} TEXMFCNF=%{_tl_texmfsysvar}/web2c:%{_tl_texmflocal}/web2c:%{_tl_texmfvine}/web2c:%{_tl_texmfdist}/web2c TEXMFCACHE=%{_tl_texmfsysvar}:%{_tl_texmfvar}; mtxrun|' %{buildroot}%{_bindir}/${x} || exit 1
done
for x in contextjit; do 
  %__sed -i -e 's|luajittex --luaonly|export TEXMF=%{_tl_texmfconfig}:%{_tl_texmfvar}:%{_tl_texmfhome}:%{_tl_texmfsysconfig}:%{_tl_texmfsysvar}:%{_tl_texmflocal}:%{_tl_texmfvine}:%{_tl_texmfdist} TEXMFCNF=%{_tl_texmfsysvar}/web2c:%{_tl_texmflocal}/web2c:%{_tl_texmfvine}/web2c:%{_tl_texmfdist}/web2c TEXMFCACHE=%{_tl_texmfsysvar}:%{_tl_texmfvar}; luajittex --luaonly|' %{buildroot}%{_bindir}/${x} || exit 1
done

# touch ghosts
touch %{buildroot}%{_tl_texmfvine}/ls-R
touch %{buildroot}%{_tl_texmfdist}/ls-R
touch %{buildroot}%{_tl_texmfsysconfig}/ls-R
touch %{buildroot}%{_tl_texmfsysvar}/ls-R

%__mkdir_p %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/
%__mkdir_p %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvipdfmx/updmap/
%__mkdir_p %{buildroot}%{_tl_texmfsysvar}/fonts/map/pxdvi/updmap/
%__mkdir_p %{buildroot}%{_tl_texmfsysvar}/fonts/map/pdftex/updmap/
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/builtin35.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/psfonts_t1.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/psfonts_pk.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/download35.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/ps2pk.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvips/updmap/psfonts.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/dvipdfmx/updmap/kanjix.map
#touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/pxdvi/updmap/xdvi-ptex.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/pdftex/updmap/pdftex_dl14.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/pdftex/updmap/pdftex.map
touch %{buildroot}%{_tl_texmfsysvar}/fonts/map/pdftex/updmap/pdftex_ndl14.map


## remove unpackaging files
find %{buildroot} | %__grep -e "\\.\(la\|a\)$" | xargs %__rm -f || exit 1
find %{buildroot} | %__grep -e "\\.\(diff\|patch\)$" | xargs %__rm -f || exit 1
%__rm -f %{buildroot}%{_bindir}/tlmgr || exit 1
find %{buildroot}%{_tl_texmfvine}/fonts/map -type d | %__grep "updmap" | xargs %__rm -rf || exit 1
find %{buildroot} -type d | grep asymptote | xargs %__rm -rf || exit 1
%__rm -f %{buildroot}%{_tl_texmfvine}/dvipdfm/config/config-win32 || exit 1
%__rm -f %{buildroot}%{_infodir}/*

## use external packages (for tlnet-20191206)
# texlive-collection-base
%__rm %{buildroot}%{_tl_texmfdist}/fonts/map/glyphlist/glyphlist.txt || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/texlive/fmtutil-user.sh || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/texlive/updmap-user.sh || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/tlshell/tlshell.tcl || exit 1
# texlive-collection-bibtexextra
%__rm %{buildroot}%{_tl_texmfdist}/scripts/urlbst/urlbst || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/bib2gls/convertgls2bib.sh || exit 1
# texlive-collection-latex
%__rm %{buildroot}%{_tl_texmfdist}/scripts/context/perl/mptopdf.pl || exit 1
# texlive-collection-langcjk
%__rm %{buildroot}%{_tl_texmfdist}/scripts/jfmutil/jfmutil.pl || exit 1
# texlive-collection-langjapanese
%__rm %{buildroot}%{_tl_texmfdist}/scripts/ptex-fontmaps/kanji-config-updmap.pl || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/ptex-fontmaps/kanji-fontmap-creator.pl || exit 1
# texlive-collection-latexrecommended
%__rm %{buildroot}%{_tl_texmfdist}/scripts/lwarp/lwarpmk.lua || exit 1
# texlive-collection-latexextra
%__rm %{buildroot}%{_tl_texmfdist}/scripts/l3build/l3build.lua || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/perltex/perltex.pl || exit 1
# texlive-collection-binextra
%__rm %{buildroot}%{_tl_texmfdist}/scripts/a2ping/a2ping.pl || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/arara/arara.sh || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/bundledoc/bundledoc || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/cluttex/cluttex.lua || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/ctanbib/ctanbib || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/dviasm/dviasm.py || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/latexindent/latexindent.pl || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/ltximg/ltximg.pl || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/make4ht/make4ht || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/pdfbook2/pdfbook2 || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/pdfjam/pdfjam || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/tex4ebook/tex4ebook || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/tlcockpit/tlcockpit.sh || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/xindex/xindex.lua || exit 1
# texlive-collection-luatex
%__rm %{buildroot}%{_tl_texmfdist}/scripts/checkcites/checkcites.lua || exit 1
# texlive-collection-plaingeneric
%__rm %{buildroot}%{_tl_texmfdist}/scripts/tex4ht/xhlatex.sh || exit 1
# texlive-collection-fontutils
%__rm %{buildroot}%{_tl_texmfdist}/scripts/fontools/afm2afm || exit 1
%__rm %{buildroot}%{_tl_texmfdist}/scripts/fontools/ot2kpx || exit 1

### Files list
find %{buildroot} -type f -or -type l | \
    %__sed -e "s|%{buildroot}||g" | \
    %__grep -v -e ".patch$" -e "\.diff$" -e "\.orig$" | \
    %__grep -v "%{_includedir}" | \
    %__grep -v "%{_libdir}" | \
    %__grep -v "%{_infodir}" | \
    %__sed -e "s|.*ls-R$|%ghost &|" \
           -e "s|.*/updmap.*\.cfg$|%config(noreplace) &|" \
           -e "s|.*/dvipdfmx\.cfg$|%config(noreplace) &|" \
           -e "s|.*xdvi\.cfg$|%config(noreplace) &|" \
           -e "s|.*\.cnf$|%config(noreplace) &|" \
	   -e "s|%{_tl_texmfvine}*/xdvi/XDvi|%config(noreplace) &|" \
           -e "s|%{_tl_texmfvine}*/web2c/texmfcnf\.lua$|%config(noreplace) &|" \
	   -e "s|^.*/updmap/$|%config &|" \
           -e "s|%{_tl_texmfvine}*/texconfig/tcfmgr.map$|%config &|" \
	   -e "s|%{_tl_texmfvine}*/dvips/config/.*$|%config &|" \
           -e "s|%{_tl_texmfvine}*/dvips/tetex/config.*$|%config &|" \
           -e "s|%{_tl_texmfvine}*/dvipdfm/config/config$|%config &|" \
           -e "s|%{_tl_texmfvine}*/fonts/map/dvips/tetex/.*.map$|%config &|" \
           -e "s|%{_tl_texmfvine}*/fonts/map/dvipdfmx/.*.map$|%config &|" \
	   -e "s|%{_tl_texmfvine}*/tex/generic/config/.*|%config &|" \
           -e "s|%{_tl_texmfvine}*/ttf2pk/ttf2pk\.cfg$|%config &|" \
           -e "s|%{_tl_texmfvine}*/hbf2gf/.*\.cfg$|%config &|" \
           -e "s|%{_tl_texmfvine}*/chktex/chktexrc$|%config &|" \
	   -e "s|%{_mandir}/.*|&*|" \
	> %{builddir}/filelist.full
#           -e "s|%{_tl_texmfsysvar}/fonts/map/dvipdfmx/vine/.*\.map$|%ghost &|" \
#           -e "s|%{_tl_aliasttfdir}/.*\.ttf$|%ghost &|" \

find %{buildroot}%{_tl_texmfvine}* -type d | \
    %__sed -e "s|^%{buildroot}|%dir |" \
	   -e "s|$|/|" >> %{builddir}/filelist.full

## subpackages
%__grep -e "/texmf/doc/" -e "/texmf-dist/doc/" -e "/texdoc" %{builddir}/filelist.full > %{builddir}/filelist.doc
cat %{builddir}/filelist.doc \
    %{builddir}/filelist.full | \
    sort | uniq -u > %{builddir}/filelist.tmp
%__mv -f %{builddir}/filelist.tmp %{builddir}/filelist.full


%clean
%__rm -rf %{buildroot}


%pretrans
rpm -q texlive | grep -q -e 2009 -e 2011 -e 2012 -e 2013 -e 2014 -e 2015 -e 2016
[ $? -eq 1 ] && exit 0
_trans_time=$(date +%Y%m%d)
/bin/echo "Running some transitional processes on your TeX system ... "
x=(
    /opt/osxws/share/texmf-local
    /opt/osxws/share/texmf-var
    /opt/osxws/share/texmf-config
)
for dir in ${x[@]}; do
    _trans_dir=${dir}.${_trans_time}.rpmorig
    [ -d ${_trans_dir}.old ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${_trans_dir}.old: " && \
        /bin/echo -n "    " && \
        %__rm -rvf ${_trans_dir}.old
    [ -d ${_trans_dir} ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${_trans_dir}: " && \
        /bin/echo -n "    " && \
        %__mv -v ${_trans_dir} ${_trans_dir}.old
    [ -d ${dir} ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${dir}: " && \
        /bin/echo -n "    " && \
        %__mv -v ${dir} ${_trans_dir}
done

for USER in `/usr/bin/dscl . -list Users | egrep -v -e ^_ -e daemon -e nobody -e root`
do
    USERHOMEDIR="`/usr/bin/dscl . -read /users/${TARGET} home | cut -f2 -d ' '`"
    dir="${USERHOMEDIR}/.texmf-var"
    _trans_dir="${dir}.${_trans_time}.rpmorig"
    [ -d "${_trans_dir}.old" ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${_trans_dir}.old: " && \
        /bin/echo -n "    " && \
        %__rm -rvf "${_trans_dir}.old"
    [ -d ${_trans_dir} ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${_trans_dir}: " && \
        /bin/echo -n "    " && \
        %__mv -v "${_trans_dir}" "${_trans_dir}.old"
    [ -d ${dir} ] && \
        /bin/echo -n "  " && \
        /bin/echo "Found ${dir}: " && \
        /bin/echo -n "    " && \
        %__mv -v "${dir}" "${_trans_dir}"
done

echo "done."

%postun
if [ "$1" = 0 ]; then
    %__rm -rf %{_tl_vartexfonts}
fi
exit 0

%post
%_tl_touch_run texhash
%_tl_touch_run updmap
%_tl_touch_run mtxrun
%_tl_touch_run fmtutil
exit 0

%posttrans
%__mkdir_p %{_tl_vartexfonts}
%__chmod 1777 %{_tl_vartexfonts}

## create our map files {ptex,uptex,otf,otf-up}-vine.map
( %{_tl_exec_upddeffont} ) ||:

%{_tl_exec_texhash}
%{_tl_exec_mtxrun}
%{_tl_exec_updmap}
%{_tl_exec_fmtutil}
exit 0

%post -n libkpathsea
# for x in kpathsea tds web2c; do 
#     /sbin/install-info %{_infodir}/${x}.info.* %{_infodir}/dir
# done

# %preun -n libkpathsea
# if [ "$1" = 0 ]; then
#     for x in kpathsea tds web2c; do 
#         /sbin/install-info --delete %{_infodir}/${x}.info.* %{_infodir}/dir
#     done
# fi

%triggerin -- ghostscript
%__rm -f %{_tl_texmfvine}/fonts/cmap/ghostscript
if [ -d "%{_datadir}/ghostscript/$(gs --version| cut -d . -f 1-2)/Resource/CMap" ] ; then
    %__ln_s %{_datadir}/ghostscript/$(gs --version| cut -d . -f 1-2)/Resource/CMap %{_tl_texmfvine}/fonts/cmap/ghostscript
elif [ -d "%{_datadir}/ghostscript/Resource/CMap" ] ; then
    %__ln_s %{_datadir}/ghostscript/Resource/CMap %{_tl_texmfvine}/fonts/cmap/ghostscript
fi
%_tl_touch_run texhash
exit 0


%files -f filelist.full
%defattr(-,root,wheel)
%{_libdir}/libtexlua53.*.dylib
%{_libdir}/libtexlua53.dylib
%{_libdir}/libtexluajit.*.dylib
%{_libdir}/libtexluajit.dylib
%{_libdir}/libsynctex.*.dylib
%{_libdir}/libsynctex.dylib
%{_libdir}/pkgconfig/*.pc
%dir %{_includedir}/synctex
%dir %{_includedir}/texlua53
%dir %{_includedir}/texluajit
%{_includedir}/synctex/*
%{_includedir}/texlua53/*
%{_includedir}/texluajit/*
#%dir %{_tl_aliasttfdir}
%attr(1777,root,wheel) %dir %{_tl_vartexfonts}
# %config %{_sysconfdir}/cron.daily/texlive.cron

%files doc -f filelist.doc
%defattr(-,root,wheel)

%files -n libkpathsea
%defattr(-,root,wheel)
%{_libdir}/libkpathsea.*.dylib
# %{_infodir}/kpathsea.info*

%files -n libkpathsea-devel
%defattr(-,root,wheel)
%{_libdir}/libkpathsea.dylib
%dir %{_includedir}/kpathsea
%{_includedir}/kpathsea/*

%files -n libptexenc
%defattr(-,root,wheel)
%{_libdir}/libptexenc.*.dylib

%files -n libptexenc-devel
%defattr(-,root,wheel)
%{_libdir}/libptexenc.dylib
%dir %{_includedir}/ptexenc
%{_includedir}/ptexenc/*


%changelog
* Mon Sep 14 2020 FUJII Keisuke <keisuke.fujii@kek.jp> 2019-1
- removed poppler patches
- use builtin poppler and xpdf
- added failedtests patch

* Thu Dec 05 2019 KOBAYASHI Taizo <tkoba965@me.com> 2019-0
- new upstream release

* Thu Dec 20 2018 KOBAYASHI Taizo <tkoba965@me.com> 2016-5
- kanji-config-updmap-highsierra.diff: more fix

* Wed Oct 11 2017 KOBAYASHI Taizo <tkoba965@me.com> 2016-4
- kanji-config-updmap-highsierra.diff:

* Fri Jan 13 2017 KOBAYASHI Taizo <tkoba965@me.com> 2016-3
- kanji-config-updmap-osxws-2016.diff:
  OTF-Morisawa-basic7: use TeX Live original maps

* Thu Jan 05 2017 KOBAYASHI Taizo <tkoba965@me.com> 2016-2
- tlnet-20161222

* Mon Jun 13 2016 KOBAYASHI Taizo <tkoba965@me.com> 2016-1
- synced with Vine 2016-3

* Wed Jan 13 2016 KOBAYASHI Taizo <tkoba965@me.com> 2015-3
- rpath fix for synctex, luatex

* Thu Dec 24 2015 KOBAYASHI Taizo <tkoba965@me.com> 2015-2
- luatex for ElCapitan
- use luatex-svn5328-otc_20151005.diff instead of luatex-beta-0.87.0

* Thu Dec 17 2015 KOBAYASHI Taizo <tkoba965@me.com> 2015-1
- synced with Vine 2015-2

* Tue May 27 2014 KOBAYASHI Taizo <tkoba965@me.com> 2014-2
- maintain HOME/.texmf-var in "pretrans" section

* Mon May 26 2014 KOBAYASHI Taizo <tkoba965@me.com> 2014-1
- synced with Vine 2014-1

* Fri May 23 2014 KOBAYASHI Taizo <tkoba965@me.com> 2013-6
- added texlive-20131101-{lua52,clang503}.patch
  for Xcode 5.1 on OSX 10.9

* Sat Jan 11 2014 KOBAYASHI Taizo <tkoba965@me.com> 2013-5
- Requires: libkpathsea and libptexenc

* Fri Jan 10 2014 KOBAYASHI Taizo <tkoba965@me.com> 2013-4
- Requires: poppler and libpaper

* Sat Nov 09 2013 KOBAYASHI Taizo <tkoba965@me.com> 2013-3
- enable xdv2pdf
- drop vine map files for dvipdfmx
  (osxws:00356)

* Tue Nov 05 2013 KOBAYASHI Taizo <tkoba965@me.com> 2013-2
- enable xetex

* Fri Nov 01 2013 KOBAYASHI Taizo <tkoba965@me.com> 2013-1
- modified for OSXWS

* Mon Oct  7 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2013-4
- updated texlive-20131002-texmfcnf-vine.patch: 
  texmf.cnf (shell_escape_commands): added some programs

* Wed Oct  2 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2013-3
- texlive-source-20131002 2014/dev + tlptexlive 20130815
- defined %%global __find_requires find-requires-texlive.sh
  - dropped unused dependencies of Requires

* Thu Sep 19 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2013-2
- texlive-source-20130919 2014/dev + tlptexlive 20130815
- correct some scripts of README.vine for each texmf trees

* Fri Aug 23 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2013-1
- upgrade to TeX Live 2013
  - texlive-source-20130823 2014/dev + tlptexlive 20130815
- dropped Requires: jvf

* Thu May 16 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2012-4
- update enhancement binaries TeX Live 2013/dev 20130106 snapshot (tlptexlive-20130106)
- fixed duplicated lw35 for updmap.pl
- updated updmap.cfg.texlive-20120701: use ipaex as kanjiEmbed

* Sat Mar  9 2013 Munehiro Yamamoto <munepi@vinelinux.org> 2012-3
- touch the map files generated by updmap-sys

* Mon Nov 26 2012 Munehiro Yamamoto <munepi@vinelinux.org> 2012-2
- fixed Source7: updmap.cfg.texlive-20120701 
  (upto /etc/texmf/web2c/updmap.cfg)
- fixex %%triggerin -- ghostscript
  - replaced %%exec_texhash with %%touch_run texhash

* Wed Nov 21 2012 Munehiro Yamamoto <munepi@vinelinux.org> 2012-1
- TeX Live 2012 + tlptexlive 20121107

* Tue Oct 30 2012 Munehiro Yamamoto <munepi@vinelinux.org> 2011-7
- drop BR: poppler-devel temporaly
  - modify tl11supp-120120-vine.patch, texlive-20110705-vine.patch to do that

* Mon May 28 2012 Munehiro Yamamoto <munepi@vinelinux.org> 2011-6
- build with poppler-0.18.4
- remove tlmgr

* Thu Jan 26 2012 Munehiro Yamamoto <munepi@vinelinux.org> 2011-5
- updated to tl11supp-120120
- run %%{exec_fmtutil} at %%post when upgrading

* Sat Dec 17 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2011-4
- updated to tl11supp-111214

* Sat Dec  3 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2011-3
- added BuildRequires: texlive-common
  - Babel needs docstrip.tex, which is contained in texlive-collection-latex
  - check japanese.ldf
- updated tl11supp-111120-vine.patch
  - added the following options to $$TL_CONFIGURE_ARGS: 
    --disable-detex 
    --disable-dvipng
    --disable-lcdf-typetools
- remove some files of asymptote
- remove a man file of latexmk
- remove man files of lcdf-typetools
- remove man files of dvipng
- remove a man file of detex

* Mon Nov 28 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2011-2
- added find-provides-texlive.sh and set it to %%__find_provides
  - use to find library sonames for libkpathsea and libptexenc
- added cmex.enc (%%{SOURCE110})
  - do not install cmex.enc in our TDS, yet
- removed some unused directories in texmf/fonts/map
- removed man files of lcdf-typetools
- moved texdoc{,tk} and its related files to texlive-doc

* Wed Nov 23 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2011-1
- TeX Live 2011 + tl11supp-111120

* Thu Oct 13 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-22
- make the directory VARTEXFONTS (%%posttrans)
  - dropped %%triggerpostun -- texlive < 2009-17vl6

* Tue Jul 19 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-21
- fixed ptexlive-20100711-dvipdfmx-vine.patch
  - for dvipdfmx.cfg, given some ps2pdf's parameters mistaked

* Thu Jun 16 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-20
- added %%pre to avoid conflictions of texmf-{config,var}

* Sun May 22 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-19
- dropped Requires: texlive-common
- added perl-Tk-TableMatrix
  - supported texdoctk
- removed broken symbolic links in /usr/bin
  - for each these symbolic links, the package of its real file/path 
    should be its owner. 

* Thu May 19 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-18
- added %%triggerpostun -- texlive < 2009-17vl6
  - make the directory VARTEXFONTS

* Tue May 10 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-17
- fixed %%dir VARTEXFONTS around in %%files
- dropped BuildRequires: t1utils

* Tue Apr 26 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-16
- updated texlive-20091107-texmfcnf-vine.patch, texlive.cron
  - changed VARTEXFONTS to /var/lib/texmf/fonts

* Mon Apr 25 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-15
- fixed updmap.cfg

* Sun Mar 27 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-14
- dropped Requires: texlive-macros

* Sat Jan 15 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-13
- updated ptexlive-20100711-pxdvik-vine.patch 
  and added texlive-20091107-xdvik-vine.patch
  - fixed to adjust X resources in texmf/xdvi/XDvi for (p)xdvi

* Sat Jan 08 2011 Munehiro Yamamoto <munepi@vinelinux.org> 2009-12
- supported Vine Linux 5
  - for vl5, changed a requirement of Japanese VF package
    - added Requires: texlive-jvf = 2009 (vl5)
- dropped dependencies of Provides:/Obsoletes: tags
  - merged these dependencies in texlive-common-vl.spec

* Wed Dec 01 2010 Shu KONNO <owa@bg.wakwak.com> 2009-11
- rebuilt with poppler-0.14.2 (libpoppler has been up to so.7)

* Fri Sep 24 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-10
- applied some security patches from Debian
  - texlive-2009-CVE-2010-0827.patch
  - texlive-2009-CVE-2010-1440.patch
- applied texlive-2009-pdftexdir-libpoppler-0.12.patch from Debian
- applied texlive-2009-luatexdir-libpoppler-0.12.patch
  based on texlive-2009-pdftexdir-libpoppler-0.12.patch
- fixed some dependencies

* Mon Aug 09 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-9
- added BuildArch: noarch in %%package doc
- removed some comment-out sentences

* Tue Jul 20 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-8
- separeted texmf-dist to texlive-common package

* Mon Jul 19 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-7
- unpacked texlive-20091107-source.tar.xz
- babel is available now
- applied eptex-100420 and some patches: 
  - eptex-100420-vine.patch
  - eptex-100420-patch1.diff

* Tue Jul 13 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-6
- updated ptexlive-20100711

* Sat Jun 12 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-5
- customized updmap.cfg to correspond installed fonts

* Mon May 31 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-4
- fixed insttexfont()

* Mon May 17 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-3
- added jvf of MORISAWA basic 5 fonts
- added cm-super, mathdesign in fntlst

* Sun May 16 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-2
- define insttexfont() in %%install
  - copy almost compatible tetex-3.0

* Sat May 08 2010 Munehiro Yamamoto <munepi@vinelinux.org> 2009-1
- ptexlive-20090322 + TeXLive 2009
- added BuildRequires: openssl-devel

* Sun Dec 06 2009 Munehiro Yamamoto <munepi@vinelinux.org> 2008-0.20091206
- ptexlive-20091009 + TeXLive 2008
